diff --git a/src/fringe.c b/src/fringe.c
index a1016ad..2a5573a 100644
--- a/src/fringe.c
+++ b/src/fringe.c
@@ -433,6 +433,402 @@ static unsigned short empty_line_bits[] = {
   0x00, 0x3c, 0x00, 0x00, 0x3c, 0x00, 0x00, 0x3c, 0x00};
 
 
+/* *************************************************************************** */
+/* begin MULTIPLE CURSORS */
+
+/* `+-fringe-helper-decimal' defined in `crosshairs.el` */
+
+/* 24
+    (+-fringe-helper-hexadecimal
+      "x......."
+      "x......."
+      "x......."
+      "x..xx..."
+      "x...xx.."
+      "x....xx."
+      "x.xxxxxx"
+      "x.xxxxxx"
+      "x....xx."
+      "x...xx.."
+      "x..xx..."
+      "x......."
+      "x......."
+      "x.......")
+*/
+static unsigned short mc_vertical_bar_right_arrow_bits[] ={
+  0x80, 0x80, 0x80, 0x98, 0x8c, 0x86, 0xbf,
+  0xbf, 0x86, 0x8c, 0x98, 0x80, 0x80, 0x80};
+
+/* 25
+    (+-fringe-helper-hexadecimal
+      "xxxxxxxx"
+      "x......x"
+      "x......x"
+      "x..xx..x"
+      "x...xx.x"
+      "x....xxx"
+      "x.xxxxxx"
+      "x.xxxxxx"
+      "x....xxx"
+      "x...xx.x"
+      "x..xx..x"
+      "x......x"
+      "x......x"
+      "xxxxxxxx")
+*/
+static unsigned short mc_hollow_rectangle_right_arrow_bits[] ={
+  0xff, 0x81, 0x81, 0x99, 0x8d, 0x87, 0xbf,
+  0xbf, 0x87, 0x8d, 0x99, 0x81, 0x81, 0xff};
+
+/* 26
+    (+-fringe-helper-hexadecimal
+      "xxxxxxxx"
+      "x......x"
+      "x......x"
+      "x......x"
+      "x......x"
+      "x......x"
+      "x......x"
+      "x......x"
+      "x......x"
+      "x......x"
+      "x......x"
+      "x......x"
+      "x......x"
+      "xxxxxxxx")
+*/
+static unsigned short mc_hollow_rectangle_bits[] ={
+  0xff, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81,
+  0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0xff};
+
+/* 27
+    (+-fringe-helper-hexadecimal
+      "x......."
+      "x......."
+      "x......."
+      "x......."
+      "x......."
+      "x......."
+      "x......."
+      "x......."
+      "x......."
+      "x......."
+      "x......."
+      "x......."
+      "x......."
+      "x.......")
+*/
+static unsigned short mc_vertical_bar_bits[] ={
+  0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80,
+  0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80};
+
+/* 28
+    (+-fringe-helper-hexadecimal
+      "xx......"
+      "xx......"
+      " xx....."
+      ".xx....."
+      "..xx...."
+      "..xx...."
+      "...xx..."
+      "...xx..."
+      "....xx.."
+      "....xx.."
+      ".....xx."
+      ".....xx."
+      "......xx"
+      "......xx")
+*/
+static unsigned short mc_backslash_bits[] ={
+  0xc0, 0xc0, 0xe0, 0x60, 0x30, 0x30, 0x18, 0x18, 0xc, 0xc, 0x6, 0x6, 0x3, 0x3};
+
+/* 29
+    (+-fringe-helper-hexadecimal
+      "xx......"
+      "xx......"
+      "xxx....."
+      "xxx....."
+      "x.xx...."
+      "x.xx...."
+      "x..xx..."
+      "x..xx..."
+      "x...xx.."
+      "x...xx.."
+      "x....xx."
+      "x....xx."
+      "x.....xx"
+      "x.....xx")
+*/
+static unsigned short mc_vertical_bar_backslash_bits[] ={
+  0xc0, 0xc0, 0xe0, 0xe0, 0xb0, 0xb0, 0x98,
+  0x98, 0x8c, 0x8c, 0x86, 0x86, 0x83, 0x83};
+
+/* 30
+    (+-fringe-helper-hexadecimal
+      ".xxxxxx."
+      "xxxx.x.."
+      "xxxx.x.."
+      "xxxx.x.."
+      ".xxx.x.."
+      "...x.x.."
+      "...x.x.."
+      "...x.x.."
+      "...x.x.."
+      "...x.x.."
+      "...x.x..")
+*/
+static unsigned short mc_pilcrow_bits[] ={
+  0x7e, 0xf4, 0xf4, 0xf4, 0x74, 0x14, 0x14, 0x14, 0x14, 0x14, 0x14};
+
+/* 31
+    (+-fringe-helper-hexadecimal
+      "..xxxx.."
+      ".xxxxxx."
+      "x..xx..x"
+      "x..xx..x"
+      "xxxxxxxx"
+      "xx....xx"
+      "xxx..xxx"
+      ".xxxxxx."
+      "..xxxx..")
+*/
+static unsigned short mc_smiley_face_bits[] ={
+  0x3c, 0x7e, 0x99, 0x99, 0xff, 0xc3, 0xe7, 0x7e, 0x3c};
+
+/* 32
+    (+-fringe-helper-hexadecimal
+      "..x....."
+      "...x...."
+      "....x..."
+      ".....x.."
+      "....x..."
+      "...x...."
+      "..x.....")
+*/
+static unsigned short mc_single_angle_right_bits[] ={
+  0x20, 0x10, 0x8, 0x4, 0x8, 0x10, 0x20};
+
+/* 33
+    (+-fringe-helper-hexadecimal
+      ".....x.."
+      "....x..."
+      "...x...."
+      "..x....."
+      "...x...."
+      "....x..."
+      ".....x..")
+*/
+static unsigned short mc_single_angle_left_bits[] ={
+  0x4, 0x8, 0x10, 0x20, 0x10, 0x8, 0x4};
+
+/* 34
+    (+-fringe-helper-hexadecimal
+      "xx.xx..."
+      ".xx.xx.."
+      "..xx.xx."
+      "...xx.xx"
+      "..xx.xx."
+      ".xx.xx.."
+      "xx.xx...")
+*/
+static unsigned short mc_double_angle_right_bits[] ={
+  0xd8, 0x6c, 0x36, 0x1b, 0x36, 0x6c, 0xd8};
+
+/* 35
+    (+-fringe-helper-hexadecimal
+      "...xx.xx"
+      "..xx.xx."
+      ".xx.xx.."
+      "xx.xx..."
+      ".xx.xx.."
+      "..xx.xx."
+      "...xx.xx")
+*/
+static unsigned short mc_double_angle_left_bits[] ={
+  0x1b, 0x36, 0x6c, 0xd8, 0x6c, 0x36, 0x1b};
+
+/* 36
+    (+-fringe-helper-hexadecimal
+      "x.x.x..."
+      ".x.x.x.."
+      "..x.x.x."
+      "...x.x.x"
+      "..x.x.x."
+      ".x.x.x.."
+      "x.x.x...")
+*/
+static unsigned short mc_triple_angle_right_bits[] ={
+  0xa8, 0x54, 0x2a, 0x15, 0x2a, 0x54, 0xa8};
+
+/* 37
+    (+-fringe-helper-hexadecimal
+      "...x.x.x"
+      "..x.x.x."
+      ".x.x.x.."
+      "x.x.x..."
+      ".x.x.x.."
+      "..x.x.x."
+      "...x.x.x")
+*/
+static unsigned short mc_triple_angle_left_bits[] ={
+  0x15, 0x2a, 0x54, 0xa8, 0x54, 0x2a, 0x15};
+
+/* 38
+    (+-fringe-helper-hexadecimal
+      "........"
+      "........"
+      "........"
+      "........"
+      "...x...."
+      "..x.x..."
+      ".x...x.."
+      "x.....x."
+      "........"
+      "........"
+      "........"
+      "........")
+*/
+static unsigned short mc_single_angle_up_bits[] ={
+  0x00, 0x00, 0x00, 0x00, 0x10, 0x28, 0x44, 0x82, 0x00, 0x00, 0x00, 0x00};
+
+/* 39
+    (+-fringe-helper-hexadecimal
+      "........"
+      "........"
+      "........"
+      "........"
+      "x.....x."
+      ".x...x.."
+      "..x.x..."
+      "...x...."
+      "........"
+      "........"
+      "........"
+      "........")
+*/
+static unsigned short mc_single_angle_down_bits[] ={
+  0x00, 0x00, 0x00, 0x00, 0x82, 0x44, 0x28, 0x10, 0x00, 0x00, 0x00, 0x00};
+
+/* 40
+    (+-fringe-helper-hexadecimal
+      "........"
+      "........"
+      "........"
+      "...x...."
+      "..x.x..."
+      ".x...x.."
+      "x..x..x."
+      "..x.x..."
+      ".x...x.."
+      "x.....x."
+      "........"
+      "........"
+      "........")
+*/
+static unsigned short mc_double_angle_up_bits[] ={
+  0x00, 0x00, 0x00, 0x10, 0x28, 0x44, 0x92, 0x28, 0x44, 0x82, 0x00, 0x00, 0x00};
+
+/* 41
+    (+-fringe-helper-hexadecimal
+      "........"
+      "........"
+      "........"
+      "x.....x."
+      ".x...x.."
+      "..x.x..."
+      "x..x..x."
+      ".x...x.."
+      "..x.x..."
+      "...x...."
+      "........"
+      "........"
+      "........")
+*/
+static unsigned short mc_double_angle_down_bits[] ={
+  0x00, 0x00, 0x00, 0x82, 0x44, 0x28, 0x92, 0x44, 0x28, 0x10, 0x00, 0x00, 0x00};
+
+/* 42
+    (+-fringe-helper-hexadecimal
+      "........"
+      "...x...."
+      "..x.x..."
+      ".x...x.."
+      "x..x..x."
+      "..x.x..."
+      ".x...x.."
+      "x..x..x."
+      "..x.x..."
+      ".x...x.."
+      "x.....x."
+      "........")
+*/
+static unsigned short mc_triple_angle_up_bits[] ={
+  0x00, 0x10, 0x28, 0x44, 0x92, 0x28, 0x44, 0x92, 0x28, 0x44, 0x82, 0x00};
+
+/* 43
+    (+-fringe-helper-hexadecimal
+      "........"
+      "x.....x."
+      ".x...x.."
+      "..x.x..."
+      "x..x..x."
+      ".x...x.."
+      "..x.x..."
+      "x..x..x."
+      ".x...x.."
+      "..x.x..."
+      "...x...."
+      "........")
+*/
+static unsigned short mc_quadruple_angle_down_bits[] ={
+  0x00, 0x82, 0x44, 0x28, 0x92, 0x44, 0x28, 0x92, 0x44, 0x28, 0x10, 0x00};
+
+/* 44
+    (+-fringe-helper-hexadecimal
+      "...x...."
+      "..x.x..."
+      ".x...x.."
+      "x..x..x."
+      "..x.x..."
+      ".x...x.."
+      "x..x..x."
+      "..x.x..."
+      ".x...x.."
+      "x..x..x."
+      "..x.x..."
+      ".x...x.."
+      "x.....x.")
+*/
+static unsigned short mc_quadruple_angle_up_bits[] ={
+  0x10, 0x28, 0x44, 0x92, 0x28, 0x44, 0x92, 0x28, 0x44, 0x92, 0x28, 0x44, 0x82};
+
+/* 45
+    (+-fringe-helper-hexadecimal
+      "x.....x."
+      ".x...x.."
+      "..x.x..."
+      "x..x..x."
+      ".x...x.."
+      "..x.x..."
+      "x..x..x."
+      ".x...x.."
+      "..x.x..."
+      "x..x..x."
+      ".x...x.."
+      "..x.x..."
+      "...x....")
+*/
+static unsigned short mc_triple_angle_down_bits[] ={
+  0x82, 0x44, 0x28, 0x92, 0x44, 0x28, 0x92, 0x44, 0x28, 0x92, 0x44, 0x28, 0x10};
+
+/* TODO:  Add the following bitmaps:
+  (define-fringe-bitmap 'breakpoint "\x3c\x7e\xff\xff\xff\xff\x7e\x3c")
+  (define-fringe-bitmap 'hollow-right-triangle "\xe0\x90\x88\x84\x84\x88\x90\xe0") */
+
+/* end MULTIPLE CURSORS */
+/* *************************************************************************** */
+
+
 #define BYTES_PER_BITMAP_ROW  (sizeof (unsigned short))
 #define STANDARD_BITMAP_HEIGHT(bits) (sizeof (bits)/BYTES_PER_BITMAP_ROW)
 #define FRBITS(bits)  bits, STANDARD_BITMAP_HEIGHT (bits)
@@ -466,6 +862,59 @@ static struct fringe_bitmap standard_bitmaps[] =
   { FRBITS (vertical_bar_bits),       8, 0, ALIGN_BITMAP_CENTER, 0 },
   { FRBITS (horizontal_bar_bits),     8, 0, ALIGN_BITMAP_BOTTOM, 0 },
   { FRBITS (empty_line_bits),         8, 3, ALIGN_BITMAP_TOP,    0 },
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+  /* 24 */
+  { FRBITS (mc_vertical_bar_right_arrow_bits),     8, 0, ALIGN_BITMAP_CENTER, 0 },
+  /* 25 */
+  { FRBITS (mc_hollow_rectangle_right_arrow_bits), 8, 0, ALIGN_BITMAP_CENTER, 0 },
+  /* 26 */
+  { FRBITS (mc_hollow_rectangle_bits),             8, 0, ALIGN_BITMAP_CENTER, 0 },
+  /* 27 */
+  { FRBITS (mc_vertical_bar_bits),                 8, 0, ALIGN_BITMAP_CENTER, 0 },
+  /* 28 */
+  { FRBITS (mc_backslash_bits),                    8, 0, ALIGN_BITMAP_CENTER, 0 },
+  /* 29 */
+  { FRBITS (mc_vertical_bar_backslash_bits),       8, 0, ALIGN_BITMAP_CENTER, 0 },
+  /* 30 */
+  { FRBITS (mc_pilcrow_bits),                      8, 0, ALIGN_BITMAP_CENTER, 0 },
+  /* 31 */
+  { FRBITS (mc_smiley_face_bits),                  8, 0, ALIGN_BITMAP_CENTER, 0 },
+  /* 32 */
+  { FRBITS (mc_single_angle_right_bits),           8, 0, ALIGN_BITMAP_CENTER, 0 },
+  /* 33 */
+  { FRBITS (mc_single_angle_left_bits),            8, 0, ALIGN_BITMAP_CENTER, 0 },
+  /* 34 */
+  { FRBITS (mc_double_angle_right_bits),           8, 0, ALIGN_BITMAP_CENTER, 0 },
+  /* 35 */
+  { FRBITS (mc_double_angle_left_bits),            8, 0, ALIGN_BITMAP_CENTER, 0 },
+  /* 36 */
+  { FRBITS (mc_triple_angle_right_bits),           8, 0, ALIGN_BITMAP_CENTER, 0 },
+  /* 37 */
+  { FRBITS (mc_triple_angle_left_bits),            8, 0, ALIGN_BITMAP_CENTER, 0 },
+  /* 38 */
+  { FRBITS (mc_single_angle_up_bits),              8, 0, ALIGN_BITMAP_CENTER, 0 },
+  /* 39 */
+  { FRBITS (mc_single_angle_down_bits),            8, 0, ALIGN_BITMAP_CENTER, 0 },
+  /* 40 */
+  { FRBITS (mc_double_angle_up_bits),              8, 0, ALIGN_BITMAP_CENTER, 0 },
+  /* 41 */
+  { FRBITS (mc_double_angle_down_bits),            8, 0, ALIGN_BITMAP_CENTER, 0 },
+  /* 42 */
+  { FRBITS (mc_triple_angle_up_bits),              8, 0, ALIGN_BITMAP_CENTER, 0 },
+  /* 43 */
+  { FRBITS (mc_triple_angle_down_bits),            8, 0, ALIGN_BITMAP_CENTER, 0 },
+  /* 44 */
+  { FRBITS (mc_quadruple_angle_up_bits),           8, 0, ALIGN_BITMAP_CENTER, 0 },
+  /* 45 */
+  { FRBITS (mc_quadruple_angle_down_bits),         8, 0, ALIGN_BITMAP_CENTER, 0 },
+
+/* *************************************************************************** */
+
+
 };
 
 #define NO_FRINGE_BITMAP 0
@@ -1723,6 +2172,150 @@ If nil, also continue lines which are exactly as wide as the window.  */);
   DEFVAR_LISP ("fringe-bitmaps", Vfringe_bitmaps,
     doc: /* List of fringe bitmap symbols.  */);
   Vfringe_bitmaps = Qnil;
+
+
+/* *************************************************************************** */
+/* begin MULTIPLE CURSORS */
+
+  /* (get 'empty-line 'fringe) => 23 => the last standard-bitmap before this one.
+  See `fringe.el`. */
+
+  /* 24 */
+  DEFSYM (Qmc_vertical_bar_right_arrow, "+-vertical-bar-right-arrow");
+  Vfringe_bitmaps = Fcons (Qmc_vertical_bar_right_arrow, Vfringe_bitmaps);
+  Fput (Qmc_vertical_bar_right_arrow, Qfringe, make_fixnum (24));
+  /* (get '+-vertical-bar-right-arrow 'fringe) => 24 */
+
+  /* 25 */
+  DEFSYM (Qmc_hollow_rectangle_right_arrow, "+-hollow-rectangle-right-arrow");
+  Vfringe_bitmaps = Fcons (Qmc_hollow_rectangle_right_arrow, Vfringe_bitmaps);
+  Fput (Qmc_hollow_rectangle_right_arrow, Qfringe, make_fixnum (25));
+  /* (get '+-hollow-rectangle-right-arrow 'fringe) => 25 */
+
+  /* 26 */
+  DEFSYM (Qmc_hollow_rectangle, "+-hollow-rectangle");
+  Vfringe_bitmaps = Fcons (Qmc_hollow_rectangle, Vfringe_bitmaps);
+  Fput (Qmc_hollow_rectangle, Qfringe, make_fixnum (26));
+  /* (get '+-hollow-rectangle 'fringe) => 26 */
+
+  /* 27 */
+  DEFSYM (Qmc_vertical_bar, "+-vertical-bar");
+  Vfringe_bitmaps = Fcons (Qmc_vertical_bar, Vfringe_bitmaps);
+  Fput (Qmc_vertical_bar, Qfringe, make_fixnum (27));
+  /* (get '+-vertical-bar 'fringe) => 27 */
+
+  /* 28 */
+  DEFSYM (Qmc_backslash, "+-backslash");
+  Vfringe_bitmaps = Fcons (Qmc_backslash, Vfringe_bitmaps);
+  Fput (Qmc_backslash, Qfringe, make_fixnum (28));
+  /* (get '+-backslash 'fringe) => 28 */
+
+  /* 29 */
+  DEFSYM (Qmc_vertical_bar_backslash, "+-vertical-bar-backslash");
+  Vfringe_bitmaps = Fcons (Qmc_vertical_bar_backslash, Vfringe_bitmaps);
+  Fput (Qmc_vertical_bar_backslash, Qfringe, make_fixnum (29));
+  /* (get '+-vertical-bar-backslash 'fringe) => 29 */
+
+  /* 30 */
+  DEFSYM (Qmc_pilcrow, "+-pilcrow");
+  Vfringe_bitmaps = Fcons (Qmc_pilcrow, Vfringe_bitmaps);
+  Fput (Qmc_pilcrow, Qfringe, make_fixnum (30));
+  /* (get '+-pilcrow 'fringe) => 30 */
+
+  /* 31 */
+  DEFSYM (Qmc_smiley_face, "+-smiley-face");
+  Vfringe_bitmaps = Fcons (Qmc_smiley_face, Vfringe_bitmaps);
+  Fput (Qmc_smiley_face, Qfringe, make_fixnum (31));
+  /* (get '+-smiley-face 'fringe) => 31 */
+
+  /* 32 */
+  DEFSYM (Qmc_single_angle_right, "+-single-angle-right");
+  Vfringe_bitmaps = Fcons (Qmc_single_angle_right, Vfringe_bitmaps);
+  Fput (Qmc_single_angle_right, Qfringe, make_fixnum (32));
+  /* (get '+-right-single-angle 'fringe) => 32 */
+
+  /* 33 */
+  DEFSYM (Qmc_single_angle_left, "+-single-angle-left");
+  Vfringe_bitmaps = Fcons (Qmc_single_angle_left, Vfringe_bitmaps);
+  Fput (Qmc_single_angle_left, Qfringe, make_fixnum (33));
+  /* (get '+-left-double-angle 'fringe) => 33 */
+
+  /* 34 */
+  DEFSYM (Qmc_double_angle_right, "+-double-angle-right");
+  Vfringe_bitmaps = Fcons (Qmc_double_angle_right, Vfringe_bitmaps);
+  Fput (Qmc_double_angle_right, Qfringe, make_fixnum (34));
+  /* (get '+-right-double-angle 'fringe) => 34 */
+
+  /* 35 */
+  DEFSYM (Qmc_double_angle_left, "+-double-angle-left");
+  Vfringe_bitmaps = Fcons (Qmc_double_angle_left, Vfringe_bitmaps);
+  Fput (Qmc_double_angle_left, Qfringe, make_fixnum (35));
+  /* (get '+-left-double-angle 'fringe) => 35 */
+
+  /* 36 */
+  DEFSYM (Qmc_triple_angle_right, "+-triple-angle-right");
+  Vfringe_bitmaps = Fcons (Qmc_triple_angle_right, Vfringe_bitmaps);
+  Fput (Qmc_triple_angle_right, Qfringe, make_fixnum (36));
+  /* (get '+-triple-angle-right 'fringe) => 36 */
+
+  /* 37 */
+  DEFSYM (Qmc_triple_angle_left, "+-triple-angle-left");
+  Vfringe_bitmaps = Fcons (Qmc_triple_angle_left, Vfringe_bitmaps);
+  Fput (Qmc_triple_angle_left, Qfringe, make_fixnum (37));
+  /* (get '+-triple-angle-left 'fringe) => 37 */
+
+  /* 38 */
+  DEFSYM (Qmc_single_angle_up, "+-single-angle-up");
+  Vfringe_bitmaps = Fcons (Qmc_single_angle_up, Vfringe_bitmaps);
+  Fput (Qmc_single_angle_up, Qfringe, make_fixnum (38));
+  /* (get '+-single-angle-up 'fringe) => 38 */
+
+  /* 39 */
+  DEFSYM (Qmc_single_angle_down, "+-single-angle-down");
+  Vfringe_bitmaps = Fcons (Qmc_single_angle_down, Vfringe_bitmaps);
+  Fput (Qmc_single_angle_down, Qfringe, make_fixnum (39));
+  /* (get '+-single-angle-down 'fringe) => 39 */
+
+  /* 40 */
+  DEFSYM (Qmc_double_angle_up, "+-double-angle-up");
+  Vfringe_bitmaps = Fcons (Qmc_double_angle_up, Vfringe_bitmaps);
+  Fput (Qmc_double_angle_up, Qfringe, make_fixnum (40));
+  /* (get '+-double-angle-up 'fringe) => 40 */
+
+  /* 41 */
+  DEFSYM (Qmc_double_angle_down, "+-double-angle-down");
+  Vfringe_bitmaps = Fcons (Qmc_double_angle_down, Vfringe_bitmaps);
+  Fput (Qmc_double_angle_down, Qfringe, make_fixnum (41));
+  /* (get '+-double-angle-down 'fringe) => 41 */
+
+  /* 42 */
+  DEFSYM (Qmc_triple_angle_up, "+-triple-angle-up");
+  Vfringe_bitmaps = Fcons (Qmc_triple_angle_up, Vfringe_bitmaps);
+  Fput (Qmc_triple_angle_up, Qfringe, make_fixnum (42));
+  /* (get '+-triple-angle-up 'fringe) => 42 */
+
+  /* 43 */
+  DEFSYM (Qmc_triple_angle_down, "+-triple-angle-down");
+  Vfringe_bitmaps = Fcons (Qmc_triple_angle_down, Vfringe_bitmaps);
+  Fput (Qmc_triple_angle_down, Qfringe, make_fixnum (43));
+  /* (get '+-triple-angle-down 'fringe) => 43 */
+
+  /* 44 */
+  DEFSYM (Qmc_quadruple_angle_up, "+-quadruple-angle-up");
+  Vfringe_bitmaps = Fcons (Qmc_quadruple_angle_up, Vfringe_bitmaps);
+  Fput (Qmc_quadruple_angle_up, Qfringe, make_fixnum (44));
+  /* (get '+-quadruple-angle-up 'fringe) => 44 */
+
+  /* 45 */
+  DEFSYM (Qmc_quadruple_angle_down, "+-quadruple-angle-down");
+  Vfringe_bitmaps = Fcons (Qmc_quadruple_angle_down, Vfringe_bitmaps);
+  Fput (Qmc_quadruple_angle_down, Qfringe, make_fixnum (45));
+  /* (get '+-quadruple-angle-down 'fringe) => 45 */
+
+/* end MULTIPLE CURSORS */
+/* *************************************************************************** */
+
+
 }
 
 /* Garbage collection hook */
diff --git a/src/keyboard.c b/src/keyboard.c
index be727a6..0180d1a 100644
--- a/src/keyboard.c
+++ b/src/keyboard.c
@@ -1224,6 +1224,80 @@ static int read_key_sequence (Lisp_Object *, Lisp_Object,
                               bool, bool, bool, bool);
 static void adjust_point_for_property (ptrdiff_t, bool);
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+static void
+mc_switches_multiple_cursors (struct window *w, bool true_or_false_p)
+{
+#ifdef GLYPH_DEBUG
+  if (trace_redisplay_p && BUFFERP (w->contents)
+      && (!NILP (BVAR (XBUFFER (w->contents), multiple_cursors_conf))
+          || !NILP (BVAR (XBUFFER (w->contents), crosshairs))
+          || !NILP (BVAR (XBUFFER (w->contents), mc_fill_column))))
+    {
+      Lisp_Object window;
+      XSETWINDOW (window, w);
+      Lisp_Object window_string = Fprin1_to_string (window, Qnil);
+      char *window_char = SSDATA (window_string);
+      fprintf (stderr, "\nmc_switches_multiple_cursors (%s):  %s\n",
+               window_char, true_or_false_p ? "true" : "false");
+    }
+#endif
+  w->mc.draw_multiple_cursors = true_or_false_p;
+  w->mc.erase_multiple_cursors = true_or_false_p;
+}
+
+static void
+mc_switches_crosshairs (struct window *w, bool true_or_false_p)
+{
+#ifdef GLYPH_DEBUG
+  if (trace_redisplay_p && BUFFERP (w->contents)
+      && (!NILP (BVAR (XBUFFER (w->contents), multiple_cursors_conf))
+          || !NILP (BVAR (XBUFFER (w->contents), crosshairs))
+          || !NILP (BVAR (XBUFFER (w->contents), mc_fill_column))))
+    {
+      Lisp_Object window;
+      XSETWINDOW (window, w);
+      Lisp_Object window_string = Fprin1_to_string (window, Qnil);
+      char *window_char = SSDATA (window_string);
+      fprintf (stderr, "\nmc_switches_crosshairs (%s):  %s\n",
+               window_char, true_or_false_p ? "true" : "false");
+    }
+#endif
+  w->mc.draw_crosshairs = true_or_false_p;
+  w->mc.erase_crosshairs = true_or_false_p;
+  if (true_or_false_p)
+    w->must_be_updated_p = true;
+}
+
+static void
+mc_switches_fill_column (struct window *w, bool true_or_false_p)
+{
+#ifdef GLYPH_DEBUG
+  if (trace_redisplay_p && BUFFERP (w->contents)
+      && (!NILP (BVAR (XBUFFER (w->contents), multiple_cursors_conf))
+          || !NILP (BVAR (XBUFFER (w->contents), crosshairs))
+          || !NILP (BVAR (XBUFFER (w->contents), mc_fill_column))))
+    {
+      Lisp_Object window;
+      XSETWINDOW (window, w);
+      Lisp_Object window_string = Fprin1_to_string (window, Qnil);
+      char *window_char = SSDATA (window_string);
+      fprintf (stderr, "\nmc_switches_fill_column (%s):  %s\n",
+               window_char, true_or_false_p ? "true" : "false");
+    }
+#endif
+  w->mc.draw_fill_column = true_or_false_p;
+  w->mc.erase_fill_column = true_or_false_p;
+  if (true_or_false_p)
+    w->must_be_updated_p = true;
+}
+
+/* *************************************************************************** */
+
+
 Lisp_Object
 command_loop_1 (void)
 {
@@ -1419,6 +1493,16 @@ command_loop_1 (void)
       Vreal_this_command = cmd;
       safe_run_hooks (Qpre_command_hook);
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+      struct window *w = XWINDOW (selected_window);
+      mc_switches_multiple_cursors (w, true);
+
+/* *************************************************************************** */
+
+
       already_adjusted = 0;
 
       if (NILP (Vthis_command))
@@ -1565,6 +1649,18 @@ command_loop_1 (void)
       if (!NILP (KVAR (current_kboard, defining_kbd_macro))
 	  && NILP (KVAR (current_kboard, Vprefix_arg)))
 	finalize_kbd_macro_chars ();
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+      mc_switches_multiple_cursors (w, false);
+      mc_switches_crosshairs (w, false);
+      mc_switches_fill_column (w, false);
+
+/* *************************************************************************** */
+
+
     }
 }
 
@@ -2448,7 +2544,15 @@ read_char (int commandflag, Lisp_Object map,
 	  if (help_echo_showing_p && !EQ (selected_window, minibuf_window))
 	    redisplay_preserve_echo_area (5);
 	  else
-	    redisplay ();
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+	    redisplay (1);
+
+/* *************************************************************************** */
+
 
 	  if (!input_pending)
 	    /* Normal case: no input arrived during redisplay.  */
@@ -2628,7 +2732,16 @@ read_char (int commandflag, Lisp_Object map,
     {
       Fdo_auto_save (auto_save_no_message ? Qt : Qnil, Qnil);
       /* Hooks can actually change some buffers in auto save.  */
-      redisplay ();
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+      redisplay (2);
+
+/* *************************************************************************** */
+
+
     }
 
   /* Try reading using an X menu.
@@ -2692,7 +2805,16 @@ read_char (int commandflag, Lisp_Object map,
 	      && ! CONSP (Vunread_command_events))
 	    {
 	      Fdo_auto_save (auto_save_no_message ? Qt : Qnil, Qnil);
-	      redisplay ();
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+	      redisplay (3);
+
+/* *************************************************************************** */
+
+
 	    }
 	}
 
@@ -2795,7 +2917,15 @@ read_char (int commandflag, Lisp_Object map,
     {
       if (commandflag >= 0
 	  && !input_pending && !detect_input_pending_run_timers (0))
-	redisplay ();
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+	redisplay (4);
+
+/* *************************************************************************** */
+
 
       goto wrong_kboard;
     }
@@ -3093,7 +3223,15 @@ read_char (int commandflag, Lisp_Object map,
       /* Remove the help from the frame.  */
       unbind_to (count, Qnil);
 
-      redisplay ();
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+      redisplay (5);
+
+/* *************************************************************************** */
+
+
       if (EQ (c, make_fixnum (040)))
 	{
 	  cancel_echoing ();
diff --git a/src/lisp.h b/src/lisp.h
index 7e7dba6..46d9231 100644
--- a/src/lisp.h
+++ b/src/lisp.h
@@ -3579,7 +3579,15 @@ extern void message_with_string (const char *, Lisp_Object, bool);
 extern void message_log_maybe_newline (void);
 extern void update_echo_area (void);
 extern void truncate_echo_area (ptrdiff_t);
-extern void redisplay (void);
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+extern void redisplay (int);
+
+/* *************************************************************************** */
+
 
 void set_frame_cursor_types (struct frame *, Lisp_Object);
 extern void syms_of_xdisp (void);
